/**
 *    author:  tourist
 *    created: 06.10.2022 17:04:46       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  long long r;
  cin >> n >> r;
  vector<int> s(n);
  for (int i = 0; i < n; i++) {
    cin >> s[i];
  }
  vector<long long> pref(n + 1);
  for (int i = 0; i < n; i++) {
    pref[i + 1] = pref[i] + s[i];
  }
  for (int i = 0; i < n; i++) {
    int low = -1;
    int high = max(i, n - 1 - i);
    while (low < high) {
      int mid = (low + high + 1) >> 1;
      if (pref[min(i + mid + 1, n)] - pref[max(i - mid, 0)] > r) {
        high = mid - 1;
      } else {
        low = mid;
      }
    }
    cout << low << '\n';
  }
  return 0;
}
