#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

long long gcd(long long a, long long b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	long long n, d;
	cin >> n;
	
	vector <long long> a(n), p(n);
	
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		if (i == 1)
			d = gcd(p[0], p[1]);
		if (i > 1)
			d = gcd(d, p[i]);
	}
	
	long long cur = 0, ans, sum = 0;
	vector <pair <long long, int>> rem;
	for (int i = 0; i < n; i++) {
		p[i] /= d;
		if (p[i] > a[i]) sum += p[i];
		else {
            sum -= p[i];
			rem.push_back({ a[i] / p[i], i });
		}
		cur += abs(a[i] - p[i]);
	}
	ans = cur;
	
	sort(rem.begin(), rem.end());
	
	long long fg = 1, i = 0;
	while (i < rem.size()) {
		cur += sum * (rem[i].first - fg);
		ans = min(cur, ans);
		fg = rem[i].first;
		long long cs = 0;
		while (i + 1 < rem.size() && rem[i].first == rem[i + 1].first) {
			cur += -(a[rem[i].second] - fg * p[rem[i].second]) + ((fg + 1) * p[rem[i].second] - a[rem[i].second]);
			sum += 2 * p[rem[i].second];
			cs += p[rem[i].second], i++;
		}
		fg++, i++;
		cur += (sum - cs);
		ans = min(cur, ans);
	}
	
	cout << ans << '\n';
	
	return 0;
}