/**
 *    author:  tourist
 *    created: 06.10.2022 17:13:51       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<long long> s(n);
  for (int i = 0; i < n; i++) {
    cin >> s[i];
  }
  vector<long long> p(n);
  long long g = 0;
  for (int i = 0; i < n; i++) {
    cin >> p[i];
    g = __gcd(g, p[i]);
  }
  for (int i = 0; i < n; i++) {
    p[i] /= g;
  }
  auto Eval = [&](long long x) {
    long long ret = 0;
    for (int i = 0; i < n; i++) {
      ret += abs(s[i] - x * p[i]);
    }
    return ret;
  };
  long long low = 1;
  long long high = (long long) 1e9;
  while (low < high) {
    long long mid = (low + high) >> 1;
    if (Eval(mid) > Eval(mid + 1)) {
      low = mid + 1;
    } else {
      high = mid;
    }
  }
  cout << Eval(low) << '\n';
  return 0;
}
