#include "testlib.h"
#include <string>

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	
	inf.maxMessageLength = 2'000'000;
	int n = inf.readInt(2, 100'000, "n");
	inf.readSpace();
	int q = inf.readInt(1, 100'000, "q");
	inf.readEoln();
	int sm = 0;
	std::vector<int> lengths(n);
	for (int i = 0; i < n; i++) {
		std::string s = inf.readWord("[a-z]{1,100000}", "s_i");
		inf.readEoln();
		sm += s.length();
	    lengths[i] = s.length();
	}
	
	ensuref(sm <= 1'000'000, "sum length exceeds max");
	
	for (int i = 0; i < q; i++) {
		int u = inf.readInt(1, n, "first");
		inf.readSpace();
		int v = inf.readInt(1, n, "second");
		inf.readSpace();
		int c = inf.readInt(0, std::min(lengths[u - 1], lengths[v - 1]) - 1, "cut");
		inf.readEoln();
	}
	
	inf.readEof();
	
	return 0;
}