#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {
	int n, q;
	cin >> n >> q;
		
	vector <string> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	
	static unordered_map <long long, long double> m;
	cout.precision(9);
	cout << fixed;
	while (q--) {
		int u, v, c;
		cin >> u >> v >> c;
		u--, v--;
		if (u == v)
		{
		    cout << (int)s[u].length() - c << '\n';
		    continue;
		}
		long long id = min(u, v) + max(u, v) * 1000000ll + c * 1000000000000ll;
		if (m.count(id)) {
			cout << m[id] << '\n';
			continue;
		}
		int z = s[u].length() - c, x = s[v].length() - c;
		
		long double mx = 0.0, d = 1.0;
		int cnt = 1;
		int brek = 20;
		while (cnt <= min(z, x)) {
			if (s[u][z - cnt] != s[v][x - cnt])
			{
				d *= 0.5;
				if (--brek == 0)
				    break;
			}
			if (mx < (long double)(cnt) * d)
				mx = (long double)(cnt) * d;
			
			cnt++;
		}
		
		cout << mx << '\n';
		m[id] = mx;
	}
	
	return 0;
}