#include <iostream>
#include <cstdlib>
#include <cstdio>
using namespace std;

long long ones[20];

int digits(long long a)
{
    int res = 0;
    for (; a; a /= 10)
        ++res;
    return res;
}

int main()
{
    ones[1] = 1;
    for (int i = 2; i < 20; ++i)
        ones[i] = ones[i - 1] * 10 + 1;

    int res = 0;
    long long a;
    cin >> a;
    while (a)
    {
        ++res;
        int cur_digits = digits(a);
        long long b = a - ones[cur_digits];
        if (digits(b) == cur_digits)
            a = b;
        else
        {
            b = a - ones[cur_digits - 1];
            if (digits(b) == cur_digits)
                break;
            a = b;
        }
    }
    cout << res << '\n';
    return 0;
}