#include "jngen.h"
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int crutch(int l)
{
    if (rnd.next(0, 2))
        return rnd.next(0, l - 1);
    if (rnd.next(0, 1))
        return 0;
    if (l > 6 && rnd.next(0, 1))
        return rnd.next(1, 6);
    if (l > 30 && rnd.next(0, 1))
        return rnd.next(7, 30);
    return rnd.next(0, l - 1);
}

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	int s = getOpt(1);
	int f = getOpt(2);
	int q = getOpt(3);
	int t = getOpt(4);
	
	cout << n << ' ' << q << '\n';
	
	vector <string> st(n);
	int len = s / n - f;
	if (t == 1 || t == 9) {
		for (int i = 0; i < n; i++) {
			st[i] = rnds.random(len);
		}
		for (int i = len * n; i < s; i++) {
			int j = rnd.next(0, n - 1);
			while (st[j].length() >= 100000)
				j = rnd.next(0, n - 1);
			st[j] += rnds.random(1);
		}
	}
	else {
		string sw = rnds.random(len);
		for (int i = 0; i < n; i++) {
			st[i] = sw;
		}
		for (int i = len * n; i < s; i++) {
			int j = rnd.next(0, n - 1);
			while (st[j].length() >= 100000)
				j = rnd.next(0, n - 1);
			st[j] += rnds.random(1);
		}
		int mx;
		if (t == 2) mx = 0;
		if (t == 3) mx = n;
		if (t == 4) mx = s / 10;
		if (t == 5) mx = s / 5;
		if (t == 6) mx = s / 3;
		if (t == 7) mx = s / 100;
		if (t == 8) mx = s / 1000;
		while (mx--) {
			int i = rnd.next(0, n - 1);
			int j = rnd.next(0, len - 1);
			st[i][j] = rnds.random(1)[0];
		}
	}
	
	for (int i = 0; i < n; i++) {
		reverse(st[i].begin(), st[i].end());
		cout << st[i] << '\n';
	}
	if (t == 9) {
	    int i = 1, j = 2;
	    while (q--) {
	        cout << i << ' ' << j << ' ' << crutch(min(st[i - 1].length(), st[j - 1].length())) << '\n';
	        if (j < n) j++;
	        else i++, j = i + 1;
	    }
	}
	else {
    	for (int i = 0; i < q; i++) {
    	    int ii = rnd.next(1, n);
    	    int j = rnd.next(1, n);
    		cout << ii << ' ';
    		cout << j << ' ';
    		cout << crutch(min(st[ii - 1].length(), st[j - 1].length())) << '\n';
    	}
	}
	
	return 0;
}