import io,os,sys

MOD = 10**9 + 7
M = 67
EPS = 10**(-8)

def bp(a, n):
    ret = 1
    while n > 0:
        if n % 2 == 1:
            ret = (ret * a) % MOD
            n -= 1
        else:
            a = (a * a) % MOD
            n //= 2
    return ret

input = io.BytesIO(os.read(0,os.fstat(0).st_size)).readline
n, q = map(int, input().decode().split())

bpows = [1, bp(M, MOD - 2)]
pows = [1, M]

for i in range(100000):
    bpows.append((bpows[-1] * bpows[1]) % MOD)
    pows.append((pows[-1] * pows[1]) % MOD)

s = []
hsh = []
for i in range(n):
    s.append(input().decode().rstrip("\r\n"))
    
    hsh.append([])
    hsh[i].append(ord(s[i][0]) - ord('a') + 1)
    for j in range(1, len(s[i])):
        cur = ord(s[i][j]) - ord('a') + 1
        ad = (cur * pows[j]) % MOD
        hsh[i].append((hsh[i][j - 1] + ad) % MOD)

def f(i, a, b):
    ret = hsh[i][b]
    if a > 0:
        ret = (ret - hsh[i][a - 1] + MOD) % MOD
        ret = (ret * bpows[a]) % MOD
    return ret

for i in range(q):
    u, v, c = map(int, input().decode().split())
    u -= 1
    v -= 1
    z, x = len(s[u]) - c, len(s[v]) - c
    
    mx, d = 0, 1
    if s[u][z - 1] == s[v][x - 1]:
        mx = 1
    else:
        mx = 0.5
    
    end, cnt = 1, 0
    while cnt < 20 and end <= min(z, x):
        if s[u][z - end] != s[v][x - end]:
            d /= 2
            if mx + EPS < end * d:
                mx = end * d
            end += 1
            cnt += 1
            continue
        
        l, r = end, min(z, x)
        while r - l > 1:
            m = (l + r) // 2
            if f(u, z - m, z - end) == f(v, x - m, x - end):
                l = m
            else:
                r = m
        
        while min(z, x) - l - 1 >= 0 and s[u][z - l - 1] == s[v][x - l - 1]:
            l += 1
            
        if mx + EPS < l * d:
            mx = l * d
        
        end = l + 1
    
    sys.stdout.write(str(mx) + "\n")