#include "jngen.h"
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	int q = getOpt(1);
	int mx = getOpt(2);
	int t = getOpt(3);
	
	cout << n << ' ' << n - 1 << ' ' << q << '\n';
	auto g = Tree::bamboo(n);
	for (int i = 0; i < n - 1; i++) {
		int z = rnd.next(1, mx);
		int x = rnd.next(1, mx);
		if (t == 1) {
			z = mx, x = mx;
		}
		if (t == 2) {
			x = 1;
		}
		if (t == 3) {
			z = 1;
		}
		if (t == 4) {
			x = (int)sqrt(mx);
		}
		if (t == 5) {
			z = (int)sqrt(mx);
		}
		string s = to_string(z) + " " + to_string(x);
		g.setEdgeWeight(i, s);
	}
	
	cout << g.add1() << '\n';
	for (int i = 0; i < q; i++) {
		int a = rnd.next(1, mx);
		int b = rnd.next(1, mx);
		if (t == 1) {
			int q = getOpt(4);
			if (q == 2) {
				a = rnd.next(2, mx);
				b = a - 1;
			}
			if (q == 3) {
				a = rnd.next(2, mx);
				b = a - rnd.next(0, 1);
			}
		}
		if (t == 2) {
			a = 1;
			int q = getOpt(4);
			if (q == 2)
				b = rnd.next(1, mx / 2);
			if (q == 3)
				b = rnd.next(mx / 2, mx);
		}
		if (t == 3) {
			b = 1;
			int q = getOpt(4);
			if (q == 2)
				a = rnd.next(1, mx / 2);
			if (q == 3)
				a = rnd.next(mx / 2, mx);
		}
		cout << a << ' ';
		cout << b << '\n';
	}
	
	return 0;
}