/**
 *    author:  tourist
 *    created: 06.10.2022 18:45:25       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m, q;
  cin >> n >> m >> q;
  vector<vector<pair<int, double>>> g(n);
  vector<int> deg(n);
  for (int i = 0; i < m; i++) {
    int x, y, a, b;
    cin >> x >> y >> a >> b;
    --x; --y;
    g[x].push_back({y, (double) a / b});
    deg[y] += 1;
  }
  vector<int> que;
  for (int i = 0; i < n; i++) {
    if (deg[i] == 0) {
      que.push_back(i);
    }
  }
  for (int b = 0; b < (int) que.size(); b++) {
    for (auto& p : g[que[b]]) {
      int to = p.first;
      if (--deg[to] == 0) {
        que.push_back(to);
      }
    }
  }
  assert((int) que.size() == n);
  vector<double> dp(n, 0);
  dp[0] = 1e30;
  for (int i : que) {
    for (auto& p : g[i]) {
      int to = p.first;
      auto val = min(dp[i], p.second);
      dp[to] = max(dp[to], val);
    }
  }
  while (q--) {
    int a, b;
    cin >> a >> b;
    if (dp[n - 1] > (double) b / a) {
      cout << "YES" << '\n';
    } else {
      cout << "NO" << '\n';
    }
  }
  return 0;
}
